<?

// Tell the system we are in processor mode      :
$processor = 1;

// Set some initital variables
$processorVersion = "1.10";

// Includes
if (!@include "../conf/conf.php") {
	echo "Aanval BPU Fatal Error: This console is not properly configured. Please re-install.\n\n";
	echo "FILE: ../conf/conf.php - Missing or not found.\n\n";
	exit;
}
if (!@include "./processor.php") {
	echo "Aanval BPU Fatal Error: This console is not properly configured. Please re-install.\n\n";
	echo "FILE: ./processor.php - Missing or not found.\n\n";
	exit;
}

// Exit if in setup or upgrade mode
if (file_exists("../installation/setup.php")) {
	echo "Aanval In Setup / Upgrade Mode - Exiting.\n\n";
	exit;
}

// php module checking
$module = "mysql";
if (checkModule("$module") == 0) {
	procWrite("D", "----------------------------------------------------");
	procWrite("D", ":: BPU: Background Processing Unit D v$processorVersion");
	procWrite("D", "----------------------------------------------------\n");
	procWrite("D", ".! Fatal Error: $module module not available.\n");
	procwrite("D", "The required module [$module] is not available within your php binary (cgi).");
	procwrite("D", "You must recompile your php binary (cgi) with $module support.");
	procwrite("D", "This must be corrected before Aanval will operate correctly.\n");
	exit;
}
$module = "pcre";
if (checkModule("$module") == 0) {
	procWrite("D", "----------------------------------------------------");
	procWrite("D", ":: BPU: Background Processing Unit D v$processorVersion");
	procWrite("D", "----------------------------------------------------\n");
	procWrite("D", ".! Fatal Error: $module module not available.\n");
	procwrite("D", "The required module [$module] is not available within your php binary (cgi).");
	procwrite("D", "You must recompile your php binary (cgi) with $module support.");
	procwrite("D", "This must be corrected before Aanval will operate correctly.\n");
	exit;
}

// Load appropriate modules
recursiveModuleLoad(0);

// Simulate login to console
$login = new mySession("processor");

// Set Script TIMEOUT Value
set_time_limit(2000);

// Variable Initilization
$ops = new myOps();
$ops->loadOps();

// Away we go!
$start = date("U");

procWrite("D", "RESET");

procWrite("D", "----------------------------------------------------");
procWrite("D", ":: BPU: Background Processing Unit D v$processorVersion");
procWrite("D", ":: IDS: " . versionText());
procWrite("D", ":: Last processing finished " . statusProcessorLastRunDiff("D") . " seconds ago.");
procWrite("D", "----------------------------------------------------\n");

// Hold Check
if (file_exists("$root_path/tmp/holdD.tmp")) {
	procwrite("D", ":: ON HOLD -> Exiting");
	exit;
}

$objStatus = new myStatus();
$objStatus->loadStatus();
$objStatus->setStatusVar("processorD_lastRun", date("U"));
$objStatus->totalProcessorRunIncrement("D");
$objStatus->saveStatus();

// Action Processor
actionProcessor();

// AI (Artificial Intelligence)
aiProcessor();

// Mail Processor
processMail();

$end = date("U");
$seconds = $end - $start;

// Defaults
if (!$opsSetCount) $opsSetCount = 0;
if (!$opsGetCount) $opsGetCount = 0;

// Include checks
foreach (get_included_files() as $file) {
	$size = $size + filesize($file);
	$cnt++;
}
$fs = humanReadablefilesize($size) . " in $cnt";

// Footer
procWrite("D", "----------------------------------------------------");
procwrite("D", ":: Set ($opsSetCount)");
procwrite("D", ":: Get ($opsGetCount)");
procWrite("D", ":: Mem ($fs)");
procWrite("D", ":: Complete - $seconds");
procWrite("D", "----------------------------------------------------");

exit;

?>
